%if 0%{?_version:1}
%define _verstr      %{_version}
%else
%define _verstr      0.0.6
%endif

# puppetserver still runs a ruby 1.9.3 kind JRuby
%define gems trocla iuid base32 ip formatador systemu hashdiff
%define extra_gem1 pg --version=0.18.4
# we want the jruby version of pg
%define jrubyonly_gems jruby-pg
%define mrionly_gems sinatra roo simpleidn

%define checkout %(date +%Y%m%d)

%define agentdir /opt/puppetlabs/puppet
%define agentgemdir %{agentdir}/lib/ruby/gems/2.4.0/
%define servergemdir /opt/puppetlabs/server/data/puppetserver/jruby-gems

Name:		puppet-extensions
Version:	%{_verstr}
Release:	1
Summary:	Extension for the puppet-agent or puppetserver.
License:	GPLv3
Source0: puppetserver.conf

BuildRequires: puppet-agent >= 5.0
BuildRequires: puppetserver >= 5.0
BuildRequires: postgresql96
BuildRequires: postgresql96-devel
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel

%description

A set of gems for puppet agent & server

Requires: puppet-agent >= 5.0

%filter_requires_in %agentgemdir
%filter_setup

%package -n puppet-agent-extensions
Summary:	Extension for the puppet-agent.
Requires: puppet-agent >= 5.0
%description -n puppet-agent-extensions

A set of gem extensions packaged for the puppet-agent.

%package -n puppetserver-extensions
Summary:	Extension for the puppetserver.
Requires: puppetserver >= 5.0
%description -n puppetserver-extensions

A set of gem extensions packaged for the puppetserver.

%prep

mkdir server_config
cp %{SOURCE0} server_config
mkdir -p ~/.puppetlabs/etc/puppet
echo -e "[master]\nconfdir=~/puppet\ncodedir=~/puppetcode" > ~/.puppetlabs/etc/puppet/puppet.conf


%build

export PATH=$PATH:/usr/pgsql-9.6/bin
/opt/puppetlabs/puppet/bin/gem install --lock --install-dir ./agent_gems --no-ri --no-rdoc -N %{extra_gem1}
/opt/puppetlabs/puppet/bin/gem install --lock --install-dir ./agent_gems --no-ri --no-rdoc -N %{gems} %{mrionly_gems}

# so it picks up the right config
export JAVA_BIN=/usr/bin/java
export JAVA_ARGS='-Xms2g -Xmx2g -Djruby.logger.class=com.puppetlabs.jruby_utils.jruby.Slf4jLogger'
export USER=puppet
export GROUP=puppet
export INSTALL_DIR=/opt/puppetlabs/server/apps/puppetserver
export SERVICE_STOP_RETRIES=60
export START_TIMEOUT=300
export RELOAD_TIMEOUT=120
export CLASSPATH=${INSTALL_DIR}/puppet-server-release.jar
export JRUBY_JAR="${JRUBY_JAR:-${INSTALL_DIR}/jruby-1_7.jar}"
export CLASSPATH="${CLASSPATH}:${JRUBY_JAR}"
export CONFIG=./server_config
"${JAVA_BIN}" $JAVA_ARGS_CLI -Djava.security.egd=/dev/urandom \
    -cp "$CLASSPATH" \
    clojure.main -m puppetlabs.puppetserver.cli.gem \
     --config ./server_config -- install --lock --install-dir ./server_gems --no-ri --no-rdoc -N %{gems} %{jrubyonly_gems}

%install

mkdir -p %{buildroot}%{agentgemdir}
for d in specifications gems extensions; do
  mv ./agent_gems/${d} %{buildroot}%{agentgemdir}/
done
mv ./agent_gems/bin %{buildroot}%{agentdir}/bin

mkdir -p %{buildroot}%{servergemdir}
for d in bin specifications gems; do
  mv ./server_gems/${d} %{buildroot}%{servergemdir}/
done

%files -n puppet-agent-extensions
%defattr(-,root,root,-)
%{agentdir}/bin/trocla
%{agentdir}/bin/iuid
%{agentdir}/bin/rackup
%{agentdir}/bin/tilt
%{agentdir}/bin/nokogiri
%{agentgemdir}/specifications/*
%{agentgemdir}/extensions/*
%{agentgemdir}/gems/*

%files -n puppetserver-extensions
%defattr(-,root,root,-)
%{servergemdir}/*

%changelog

